#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Fri Jul 17 19:06:49 2020

@author: mlanger
"""


import os
import matplotlib.pyplot as plt
from matplotlib.colors import ListedColormap, LinearSegmentedColormap
import matplotlib as mpl
#from netCDF4 import Dataset as netcdf_dataset
import numpy as np
import json
import pandas as pd 
import scipy.io as sio
import matplotlib.path as mpath
import geopandas as gpd
import seaborn as sns
import matplotlib.patches as mpatches
from matplotlib.lines import Line2D
from matplotlib import rc

#==============================================================================
        
def moving_average(data_set, periods=3):
    weights = np.ones(periods) / periods
    return np.convolve(data_set, weights, mode='valid')

#==============================================================================

work_dir = "/home/aoehme/Documents/Python/CombiningFigure/new_figure_data/"


#==============================================================================
#                       Talik formation timing
#==============================================================================

rcp = []
rcp.append('rcp2_6')
#rcp.append('rcp8_5')
#rcp.append('HADGEM2_rcp2_6')
rcp.append('HADGEM2_rcp8_5')

df = pd.DataFrame({'lat': range(55,76+1,1) })

shapefile = work_dir + "IonP_" + "rcp2_6" + "_TalikDate.shp"
gdf = gpd.read_file(shapefile)
shapefile2 = work_dir + "IonP_" + "HADGEM2_rcp8_5" + "_TalikDate.shp"
gdf2 = gpd.read_file(shapefile2)

gdf['TalikDate'][gdf['TalikDate']==0]=2101
gdf2['TalikDate'][gdf2['TalikDate']==0]=2101
talik_no_2020 = []
talik_no_2050 = []
talik_no_2100 = []
talik_no_2101 = []
talik_no = []
site_no = []
talik_no_2020_rcp85 = []
talik_no_2050_rcp85 = []
talik_no_2100_rcp85 = []
talik_no_2101_rcp85 = []
talik_no_rcp85 = []
site_no_rcp85 = []
for lat in df['lat']:
    print(lat)  
    
    #RCP 2.6
    site_no.append( np.nansum(gdf['SiteNumber'][gdf['Latitude']==(lat + 0.5)]) )
    talik_no.append( np.nansum(gdf['SiteNumber'][(gdf['Latitude']==(lat + 0.5)) & (gdf['TalikDate']>=2050)]) )
    
    talik_no_2020.append( np.nansum(gdf['SiteNumber'][(gdf['Latitude']==(lat + 0.5)) & (gdf['TalikDate']<=2020)]) )
    talik_no_2050.append( np.nansum(gdf['SiteNumber'][(gdf['Latitude']==(lat + 0.5)) & (gdf['TalikDate']>2020) & (gdf['TalikDate']<=2050)]) )
    talik_no_2100.append( np.nansum(gdf['SiteNumber'][(gdf['Latitude']==(lat + 0.5)) & (gdf['TalikDate']>2050) & (gdf['TalikDate']<=2100)]) )
    talik_no_2101.append( np.nansum(gdf['SiteNumber'][(gdf['Latitude']==(lat + 0.5)) & (gdf['TalikDate']>2100)]) )
    
    #HADGEM RCP 8.5
    site_no_rcp85.append( np.nansum(gdf2['SiteNumber'][gdf2['Latitude']==(lat + 0.5)]) )
    talik_no_rcp85.append( np.nansum(gdf2['SiteNumber'][(gdf2['Latitude']==(lat + 0.5)) & (gdf2['TalikDate']>=2050)]) )
    
    talik_no_2020_rcp85.append( np.nansum(gdf2['SiteNumber'][(gdf2['Latitude']==(lat + 0.5)) & (gdf2['TalikDate']<=2020)]) )
    talik_no_2050_rcp85.append( np.nansum(gdf2['SiteNumber'][(gdf2['Latitude']==(lat + 0.5)) & (gdf2['TalikDate']>2020) & (gdf2['TalikDate']<=2050)]) )
    talik_no_2100_rcp85.append( np.nansum(gdf2['SiteNumber'][(gdf2['Latitude']==(lat + 0.5)) & (gdf2['TalikDate']>2050) & (gdf2['TalikDate']<=2100)]) )
    talik_no_2101_rcp85.append( np.nansum(gdf2['SiteNumber'][(gdf2['Latitude']==(lat + 0.5)) & (gdf2['TalikDate']>2100)]) )


lat = df.lat + 0.5
bars1 = np.asarray( talik_no_2020 )
bars2 = np.asarray( talik_no_2050 )
bars3 = np.asarray( talik_no_2100 )
bars4 = np.asarray( talik_no_2101 )
bars1_rcp85 = np.asarray( talik_no_2020_rcp85 )
bars2_rcp85 = np.asarray( talik_no_2050_rcp85 )
bars3_rcp85 = np.asarray( talik_no_2100_rcp85 )
bars4_rcp85 = np.asarray( talik_no_2101_rcp85 )


#==============================================================================
#           Industrial sites on degrading permafrost
#==============================================================================

rcp2 = []
rcp2.append('rcp2_6')
rcp2.append('rcp8_5')
rcp2.append('HADGEM2_rcp2_6')
rcp2.append('HADGEM2_rcp8_5')

df2 = pd.DataFrame({'year': range(1950,2100+1,1) })

for r in rcp2:
    shapefile3 = work_dir + "IonP_" + r + "_TalikDate.shp"
    gdf3 = gpd.read_file(shapefile3)
    
    site_no_x = []
    c_site_no_x = []
    for year in df2['year']:
        print(year)  
        
        site_no_x.append( np.nansum(gdf3['SiteNumber'][gdf3['TalikDate']==year]) )
        #c_site_no.append( np.nansum(gdf['SiteNumber'][gdf['CirtTempDa']==year]) )

        #site_no.append( np.sum((gdf['TalikDate']==year)) ) 


    df2[r] = np.cumsum(site_no_x)
    #df['crit_' + r] = np.cumsum(c_site_no)
    
sio.savemat(work_dir + 'IonP' + ".mat",  {name: col.values for name, col in df2.items()})

#==============================================================================
#               Load/Process Global Temperatures 
#==============================================================================

mat = sio.loadmat('/home/aoehme/Documents/ERA_DATA/global_temp_new.mat')
global_mean_temp_rcp2_6 = mat["temp_global_ext_rcp2_6"]
global_mean_temp_rcp8_5 = mat["temp_global_ext_rcp8_5"]
global_mean_temp_rcp2_6_1970_2100 = global_mean_temp_rcp2_6[1449:1600]
global_mean_temp_rcp8_5_1970_2100 = global_mean_temp_rcp8_5[1449:1600]
year_temp=np.asarray(range(501,2301))
year_1970_2100=year_temp[1449:1600]
global_mean_temp_rcp2_6_1970_2100 = global_mean_temp_rcp2_6_1970_2100.flatten()
global_mean_temp_rcp8_5_1970_2100 = global_mean_temp_rcp8_5_1970_2100.flatten()

mat2 = sio.loadmat('/home/aoehme/Documents/ERA_DATA/hadgem2_global_temp_new.mat')
had_global_mean_temp_rcp2_6 = mat2["temp_global_ext_rcp2_6"]
had_global_mean_temp_rcp8_5 = mat2["temp_global_ext_rcp8_5"]
had_global_mean_temp_rcp2_6_1970_2100 = had_global_mean_temp_rcp2_6[1449:1600]
had_global_mean_temp_rcp8_5_1970_2100 = had_global_mean_temp_rcp8_5[1449:1600]
year_temp2=np.asarray(range(501,2301))
year2_1970_2100=year_temp2[1449:1600]
had_global_mean_temp_rcp2_6_1970_2100 = had_global_mean_temp_rcp2_6_1970_2100.flatten()
had_global_mean_temp_rcp8_5_1970_2100 = had_global_mean_temp_rcp8_5_1970_2100.flatten()


#==============================================================================
#                           Plots
#==============================================================================

sns.set_style("darkgrid")
fig = plt.figure(figsize=(13,10))
#sub1 = plt.subplot2grid((2,2),(0,0), colspan = 2)
#sub2 = plt.subplot2grid((2,2),(1,0), colspan = 1)
#sub3 = plt.subplot2grid((2,2),(1,1), colspan = 1)

sub1 = plt.subplot2grid((7,2),(0,0), colspan = 2, rowspan=4)
sub2 = plt.subplot2grid((7,2),(4,0), colspan = 1, rowspan=3)
sub3 = plt.subplot2grid((7,2),(4,1), colspan = 1, rowspan=3)
plt.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=0.1, hspace=0.05)

for col in df2.columns:
    if col != 'year':
        #print col
        years = df2['year']
        df2[col] = df2[col].rolling(window=5).mean()     
        sub1.plot(df2['year'], df2[col] , marker='', color='red', linewidth=2, alpha=0.0)

#ax2 = ax.twinx()
sub1.fill_between(df2['year'], df2['rcp2_6'], df2['HADGEM2_rcp2_6'], color='#f8961e', linewidth=1, alpha=0.7, label='RCP2.6')
sub1.fill_between(df2['year'], df2['rcp8_5'], df2['HADGEM2_rcp8_5'], color='#db3a34', linewidth=1, alpha=0.7, label='RCP8.5')

sub1.set_xlim(df2.year[0],df2.year.tail(1).item())
 
#leg = sub1.legend(title='Warming scenario:', loc=2)
#bb = leg.get_bbox_to_anchor().inverse_transformed(sub1.transAxes)
## Change to location of the legend. 
#xOffset = -0.14
#bb.y0 += xOffset
#bb.y1 += xOffset
#leg.set_bbox_to_anchor(bb, transform = sub1.transAxes)

sub1.text(1956, 4950, r'Industrial sites on degrading permafrost',style='normal', fontweight='bold',fontsize=14)
sub1.text(1952.25, 4950, r'A',style='normal', fontweight='bold',fontsize=12,bbox=dict(boxstyle="round",ec="black",fc="none"))
sub2.text(25, 76.75, r'B',style='normal', fontweight='bold',fontsize=12,bbox=dict(boxstyle="round",ec="black",fc="none"))
sub3.text(25, 76.75, r'C',style='normal', fontweight='bold',fontsize=12,bbox=dict(boxstyle="round",ec="black",fc="none"))
sub2.text(43, 76.75, r'RCP2.6',style='normal', fontweight='bold',fontsize=12)
sub3.text(43, 76.75, r'RCP8.5',style='normal', fontweight='bold',fontsize=12)

#plt.ylabel("Number of sites", fontsize=12)

sub1.xaxis.label.set_color('black')
sub1.xaxis.label.set_fontsize(12)
sub1.tick_params(axis='x', labelsize= 12)
sub1.tick_params(axis='x', colors='black')

sub1.yaxis.label.set_color('black')
sub1.tick_params(axis='y', labelsize= 12)
sub1.tick_params(axis='y', colors='black')
sub1.set_ylabel("Number of sites", fontsize=12)

sub1.xaxis.set_label_position('top') 
sub1.xaxis.set_ticks_position('top')

minor_ticks = np.arange(1000,5000, 250)
minor_ticks2 = np.arange(1960,2100, 10)
sub1.set_yticks(minor_ticks, minor=True)
sub1.set_xticks(minor_ticks2, minor=True)
sub1.grid(which='minor', alpha=0.6)
sub1.set_ylim([1000,5250])

ax2=sub1.twinx()
ax2.plot(year_1970_2100[2:149],moving_average(global_mean_temp_rcp2_6_1970_2100,5),color='grey', linestyle='--', linewidth=1) #'#f48c06'
ax2.plot(year_1970_2100[2:149],moving_average(global_mean_temp_rcp8_5_1970_2100,5),color='black', linestyle='--', linewidth=1) #'#d00000'
ax2.plot(year_1970_2100[2:149],moving_average(had_global_mean_temp_rcp2_6_1970_2100,5),color='grey', linewidth=1) #'#f48c06'
ax2.plot(year_1970_2100[2:149],moving_average(had_global_mean_temp_rcp8_5_1970_2100,5),color='black', linewidth=1) #'#d00000'
ax2.set_ylim([0,5.675])
ax2.set_ylabel("Temperature anomaly [K]",color="black",fontsize=12)
ax2.tick_params(axis='y', labelsize= 12, colors='black')
ax2.grid(None)

legend_title1 = mpatches.Patch(0,0,color='red',alpha=0.0,label='Thaw affected industrial sites')
red_patch = mpatches.Patch(color='#db3a34',alpha=0.8, label='RCP8.5')
blue_patch = mpatches.Patch(color='#f8961e',alpha=0.8, label='RCP2.6')
legend_title2 = mpatches.Patch(0,0,color='red',alpha=0.0, label='Global temperature anomalies')
ccsm_rcp85 = Line2D([0], [0], color="black", linewidth=2, linestyle='--', label="RCP8.5 CCSM4")
ccsm_rcp26= Line2D([0], [0], color="grey", linewidth=2, linestyle='--', label="RCP2.6 CCSM4")
had_rcp85 = Line2D([0], [0], color="black", linewidth=2, label="RCP8.5 HadGEM2")
had_rcp26= Line2D([0], [0], color="grey", linewidth=2, label="RCP2.6 HadGEM2")
leg = sub1.legend(handles=[legend_title1, red_patch, blue_patch,legend_title2, had_rcp85,had_rcp26,ccsm_rcp85,ccsm_rcp26],bbox_to_anchor=(0,0,0.90,0.90))

t1, t2, t3, t4, t5, t6, t7, t8 = leg.get_texts()
# here we create the distinct instance
t1._fontproperties = t4._fontproperties.copy()
t1.set_color('black')
t1.set_weight('bold')
t4.set_color('black')
t4.set_weight('bold')

#colors = ['red', 'orange', 'yellow', 'white']
colors = ['#004e89','#69b3a2','white'] #'#6d6875', 'white'   #f7dc6f #f6ddcc , '#f0b27a'
labels = ["2020-2050", "2050-2100", "Stable until 2100"]
lefts=0
barWidth = 1
for bars, col, label in zip([bars2, bars3, bars4], colors, labels):
    sub2.barh(lat, bars, left=lefts, color=col, edgecolor='black', alpha = 0.8, height=barWidth, label=label)
    lefts += bars
sub2.set_ylabel('Latitude [°N]', fontsize=12, color='black')
sub2.set_xlabel('Number of industrial sites on permafrost', fontsize=12, color='black')
sub2.tick_params(axis='x', labelsize= 12, colors='black')
sub2.tick_params(axis='y', labelsize= 12, colors='black')
leg = sub2.legend(title="$\\bf{Sites\ on\ destabilized\ permafrost}$")
leg._legend_box.align = "left"
sub2.set_ylim([54,79])


lefts=0
barWidth = 1
for bars2, col, label in zip([bars2_rcp85, bars3_rcp85, bars4_rcp85], colors, labels):
    sub3.barh(lat, bars2, left=lefts, color=col, edgecolor='black', alpha = 0.8, height=barWidth, label=label)
    lefts += bars2
#sub3.set_ylabel('Latitude')
sub3.set_xlabel('Number of industrial sites on permafrost', fontsize=12, color='black')
sub3.tick_params(axis='x', labelsize= 12, colors='black')
sub3.tick_params(axis='y', labelsize= 12, colors='black')
sub3.set_ylim([54,79])
#sub2.legend()

#fig.savefig(work_dir + "IndustrialSites_TalikFormation14.png", dpi=100, transparent=False, edgecolor='none')

#==============================================================================
#==============================================================================


